## scangearmp2 4.90

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(scangearmp2-sane)

# The target architecture.
# For cross-compilation this should still work as you're supposed to set this var.
# X64 mean 64-bit generically, whether AMD64 or AARCH64.
set(TARGET_ARCH "${CMAKE_SYSTEM_PROCESSOR}" CACHE STRING "Target architecture")
# message(FATAL_ERROR ">>>[${CMAKE_SYSTEM_PROCESSOR}]")
if (TARGET_ARCH MATCHES "^mips64el")
  set(ARCH 1)
elseif (TARGET_ARCH MATCHES "^aarch64")
  set(ARCH 2)
elseif (TARGET_ARCH MATCHES "^x86_64")
  set(ARCH 3)
elseif (TARGET_ARCH MATCHES "^i686")
  set(ARCH 4)
else ()
  message(FATAL_ERROR "Arch device not supported")
endif ()

set(CMAKE_INSTALL_PREFIX "/usr")
set(CFLAGS_WARN     "-Wall -Wextra -Werror -Wno-deprecated-declarations -Wno-format-truncation -Wno-stringop-truncation")
set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} ${CFLAGS_WARN}")

include(GNUInstallDirs) # for make install

find_program(INTLTOOL_UPDATE_EXECUTABLE intltool-update)
if(NOT INTLTOOL_UPDATE_EXECUTABLE)
    message(FATAL_ERROR "Couldn't find intltool-update")
endif()

find_package(Gettext REQUIRED)
include(FindPkgConfig)
pkg_search_module(LIBUSB REQUIRED libusb-1.0)
pkg_search_module(GTK3 REQUIRED gtk+-3.0)
pkg_search_module(SANE REQUIRED sane-backends)
find_package(JPEG REQUIRED)

option(DEBUG "turn on debug info" OFF)

add_subdirectory(po)
add_subdirectory(src)

if (ARCH EQUAL 1)
add_subdirectory(usr/libmips64)
elseif (ARCH EQUAL 2)
add_subdirectory(usr/libaarch64)
elseif (ARCH EQUAL 3)
add_subdirectory(usr/lib64)
elseif (ARCH EQUAL 4)
add_subdirectory(usr/lib32)
endif()
add_subdirectory(usr/share/scangearmp2)

install(FILES "etc/udev/rules.d/80-canon_mfp2.rules" DESTINATION "/etc/udev/rules.d/")
install(FILES "etc/sane.d/dll.d/mfp2" DESTINATION "/etc/sane.d/dll.d/")
install(FILES "etc/sane.d/canon_pixma.conf" DESTINATION "/etc/sane.d/")
install(FILES "etc/canon-scan.xml" DESTINATION "/etc/")
install(FILES "usr/share/applications/scangearmp2.desktop" DESTINATION "/usr/share/applications/")

=== po/CMakeLists.txt ===
set(MO_NAME "scangearmp2.mo")
foreach(lang de fr ja zh ru)
  add_custom_command(OUTPUT "${lang}/LC_MESSAGES/${MO_NAME}"
                      COMMAND mkdir -p "${lang}/LC_MESSAGES"
                      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po" -o "${lang}/LC_MESSAGES/${MO_NAME}"
                     )
  list(APPEND MO_FILES "${lang}/LC_MESSAGES/${MO_NAME}")
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${lang}" DESTINATION "${CMAKE_INSTALL_LOCALEDIR}")
 endforeach(lang)
 add_custom_target(generate-mo ALL SOURCES ${MO_FILES})

#no need to call this target at every building - run it manually when needed.
add_custom_target(update_translations
                  COMMAND intltool-update -r -g scangearmp2
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                 )

=== src/CMakeLists.txt ===
add_executable(scangearmp2 	main.c
                            callbacks.c
                            canon_mfp_io.c
                            canon_mfp_tools.c
                            cnmsfunc.c
                            errordlg.c
                            file_control.c
                            jpeg2pdf.c
                            keep_setting.c
                            mainui.c
                            progressbar.c
                            scanmain.c
                            selectdevice.c
              )

set_target_properties(scangearmp2 PROPERTIES
                      C_STANDARD 11
                      LINK_FLAGS "-Wl,--export-dynamic")

if(DEBUG)
  target_compile_definitions(scangearmp2 PRIVATE "_SGMP_DEBUG" "_SGMP_DEBUG_VERBOSE_")
  target_compile_options(scangearmp2 PRIVATE "-O0" "-ggdb3")
else(DEBUG)
  target_compile_options(scangearmp2 PRIVATE "-O2")
endif(DEBUG)

target_include_directories(scangearmp2 PRIVATE ${GTK3_INCLUDE_DIRS} ${LIBUSB_INCLUDE_DIRS})
target_link_libraries(scangearmp2 pthread ${GTK3_LIBRARIES} ${LIBUSB_LIBRARIES})
target_link_libraries(scangearmp2 cncpmslld2 cncpnet2 cncpnet20 cncpnet30)
target_compile_definitions(scangearmp2 PRIVATE "PACKAGE_DATA_DIR=\"../share/scangearmp2\"")
target_compile_definitions(scangearmp2 PRIVATE "CNMSLIBPATH=../${CMAKE_INSTALL_LIBDIR}/bjlib")
target_compile_definitions(scangearmp2 PRIVATE "ENABLE_NLS")
install(TARGETS scangearmp2 DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(sane)

=== src/sane/CMakeLists.txt ===
add_library(sane-canon_pixma SHARED canon_pixma.c
                                    errordlg.c
                                    ../canon_mfp_io.c
                                    ../canon_mfp_tools.c
                                    ../keep_setting.c
                                    ../cnmsfunc.c
                                    ../file_control.c
           )
set_target_properties(sane-canon_pixma PROPERTIES
                      C_STANDARD 11
                      VERSION "1.0.0"
                      SOVERSION "1")

if(DEBUG)
  target_compile_definitions(sane-canon_pixma PRIVATE "_SGMP_DEBUG" "_SGMP_DEBUG_VERBOSE_")
  target_compile_options(sane-canon_pixma PRIVATE "-O0" "-ggdb3")
else(DEBUG)
  target_compile_options(sane-canon_pixma PRIVATE "-O2")
endif(DEBUG)

target_compile_definitions(sane-canon_pixma PRIVATE "SUPPORT_H_WO_GTK")
target_include_directories(sane-canon_pixma PRIVATE ${JPEG_INCLUDE_DIR} ${LIBUSB_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})
target_link_libraries(sane-canon_pixma pthread ${JPEG_LIBRARY} ${LIBUSB_LIBRARIES})
target_link_libraries(sane-canon_pixma cncpmslld2 cncpnet2 cncpnet20 cncpnet30)
target_compile_definitions(sane-canon_pixma PRIVATE "CNMSLIBPATH=../${CMAKE_INSTALL_LIBDIR}/bjlib")

install(TARGETS sane-canon_pixma DESTINATION "${CMAKE_INSTALL_LIBDIR}/sane/")

=== usr/lib64/CMakeLists.txt ===
foreach(bin_lib_file libcncpmslld2.so.3.0.0 libcncpnet2.so.1.2.5 libcncpnet20.so.1.0.0 libcncpnet30.so.1.0.0)

  #get SONAME from canon shared libs to construct symlinks
  string(REGEX REPLACE "^lib(.*)\.so.*" "\\1" bin_lib_name ${bin_lib_file})
  execute_process(COMMAND objdump -p ${bin_lib_file}
                  COMMAND grep SONAME
                  COMMAND sed "s/^[[:space:]]*SONAME[[:space:]]*//"
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  OUTPUT_VARIABLE bin_lib_soname
                  OUTPUT_STRIP_TRAILING_WHITESPACE
                 )

  # move canon shared libs from source dir to build dir and create symlinks
  add_custom_target("fake_build_${bin_lib_name}"
                    COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/${bin_lib_file}" "./"
                    COMMAND ln -sf ${bin_lib_file} ${bin_lib_soname}
                   )
  add_library(${bin_lib_name} SHARED IMPORTED GLOBAL)
  add_dependencies(${bin_lib_name} "fake_build_${bin_lib_name}")
  set_target_properties(${bin_lib_name} PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${bin_lib_file}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${bin_lib_file}"
                "${CMAKE_CURRENT_BINARY_DIR}/${bin_lib_soname}"
          DESTINATION ${CMAKE_INSTALL_LIBDIR}
          PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                      GROUP_READ GROUP_EXECUTE
                      WORLD_READ WORLD_EXECUTE
         )
endforeach(bin_lib_file)

install(DIRECTORY bjlib DESTINATION ${CMAKE_INSTALL_LIBDIR} USE_SOURCE_PERMISSIONS)

=== usr/share/scangearmp2/CMakeLists.txt ===
install(FILES scangearmp2.glade DESTINATION "${CMAKE_INSTALL_DATADIR}/scangearmp2/")
install(FILES scangearmp2.glade.h DESTINATION "${CMAKE_INSTALL_DATADIR}/scangearmp2/")
install(DIRECTORY doc DESTINATION "${CMAKE_INSTALL_DATADIR}/scangearmp2")

## scangearmp2 4.81

=== debian/changelog ===
scangearmp2 (4.81-1) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.81

 -- Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Sun, 18 May 2025 00:57:24 +0200

scangearmp2 (4.71-1) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.71

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Thu, 09 May 2024 19:50:05 +0200

scangearmp2 (4.70a-1) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.70a

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Thu, 02 Nov 2023 20:31:05 +0200

scangearmp2 (4.60.0-3) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.60

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 13 Aug 2023 20:31:05 +0200

scangearmp2 (4.50.0) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.50

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 21 Nov 2022 14:46:05 +0200

scangearmp2 (4.40.0) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.40
  * Add arrch mips64el and aarch64

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 16 Aug 2021 14:46:05 +0200

scangearmp2 (4.30.0) UNRELEASED; urgency=medium

  * Migration to scangearmp2 4.30
  * Add resolution 1200 

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 16 Aug 2021 14:46:05 +0200

scangearmp2 (4.20.4) UNRELEASED; urgency=medium

  * Add ADF and ADF Duplex
  * Add resolution 75, 150, 300 and 600 
  * Migration to scangearmp2 4.20

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 16 Aug 2021 14:46:05 +0200

scangearmp2 (4.12-1ubuntu1604+4) xenial; urgency=medium

  *Add patch to fix resolution.

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Mon, 12 Apr 2021 13:51:41 +0200

scangearmp2 (4.12-1ubuntu1604+3) xenial; urgency=medium

  * build for upstream.

 --  Thierry HUCHARD (cle ubuntu) <thierry@substantiel.fr>  Sun, 28 Feb 2021 16:32:56 +0100

scangearmp2 (3.90-1ubuntu) stable; urgency=medium

  * build for upstream. 

 -- thierry <thierry@thierry-thinkpad>  Tue, 06 dec 2017 21:03:04 +0100

scangearmp2 (3.50-2ubuntu.artful) stable; urgency=medium

  * build for artful. 

 -- thierry <thierry@thierry-thinkpad>  Tue, 05 dec 2017 21:03:04 +0100

scangearmp2 (3.50-2) stable; urgency=medium

  * Add upstream version 3.50

 -- thierry <thierry@substantiel.fr>  Tue, 05 Dec 2017 18:00:27 +0100

scangearmp2 (3.40.3+ubuntu.zesty) stable; urgency=medium

  * New release for zesty

 -- Bertie Brousse <bertie95@hotmail.fr>  Fri, 18 Aug 2017 18:01:37 +0000

scangearmp2 (3.40.3+ubuntu.xenial) stable; urgency=medium

  * New release for xenial

 -- Bertie Brousse <bertie95@hotmail.fr>  Fri, 18 Aug 2017 17:51:26 +0000

scangearmp2 (3.40.3+ubuntu.trusty) stable; urgency=medium

  * New release for trusty

 -- Bertie Brousse <bertie95@hotmail.fr>  Fri, 18 Aug 2017 17:43:03 +0000

scangearmp2 (3.40.3+debian.stretch) stable; urgency=medium

  * New release for stretch 

 -- Bertie Brousse <bertie95@hotmail.fr>  Fri, 18 Aug 2017 17:37:50 +0000

scangearmp2 (3.40.3+debian.jessie) stable; urgency=medium

  * Now works with xsane 

 -- Bertie Brousse <bertie95@hotmail.fr>  Fri, 18 Aug 2017 12:07:25 +0200

scangearmp2 (3.40.2+ubuntu.xenial) stable; urgency=medium

  * New release for xenial 

 -- Bertie Brousse <bertie95@hotmail.fr>  Wed, 16 Aug 2017 14:59:04 +0000

scangearmp2 (3.40.2+ubuntu.trusty) stable; urgency=medium

  * New release for trusty 

 -- Bertie Brousse <bertie95@hotmail.fr>  Wed, 16 Aug 2017 14:01:54 +0000

scangearmp2 (3.40.2+debian.stretch) stable; urgency=medium

  * New release for stretch

 -- Bertie Brousse <bertie95@hotmail.fr>  Wed, 16 Aug 2017 13:17:18 +0000

scangearmp2 (3.40.2+debian.jessie) stable; urgency=medium

  * This project is a sane backend for the canon's scanner,
    based on the source code of scangearmp2. 

 -- Bertie Brousse <bertie95@hotmail.fr>  Wed, 16 Aug 2017 10:19:31 +0000

scangearmp2 (3.40-2) stable; urgency=medium

  * This project is a sane backend for the canon's scanner,
    based on the source code of scangearmp2. 

 -- Bertie Brousse <bertie95@hotmail.fr>  Wed, 09 Aug 2017 16:06:15 +0200

scangearmp2 (3.40-1) stable; urgency=low

  * Initial Release.

 -- Canon Inc. <sup-debian@list.canon.co.jp>  Thu, 22 Dec 2016 12:00:00 +0900

=== debian/control ===
Source: scangearmp2
Section: graphics
Priority: optional
Maintainer: Thierry HUCHARD <thierry@substantyiel.fr>
Build-Depends: debhelper, autotools-dev, libglib2.0-dev, libgtk-3-dev, libusb-1.0-0-dev,
 libtool-bin | libtool, libjpeg-dev, autoconf, autotools-dev, gawk, automake, cmake, intltool,
 libsane-dev
Standards-Version: 3.7.2

Package: scangearmp2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmfp2-canon, libcanon-proprio-bin
Provides: libmfp2-canon, libcanon-proprio-bin
Description: ScanGear MP for Linux.
 This ScanGear MP provides scanning functions for Canon Multifunction Inkjet Printer.
